#ifndef EFL_UI_CLICKABLE_EO_HH
#define EFL_UI_CLICKABLE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_object.eo.h"
#include "efl_ui_clickable.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_object.eo.hh"
#ifndef EFL_UI_CLICKABLE_FWD_GUARD
#define EFL_UI_CLICKABLE_FWD_GUARD
namespace efl { namespace ui { 
struct Clickable;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Clickable> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Clickable&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Clickable const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Clickable const&> : ::std::true_type {}; } }
#endif
#ifndef EFL_OBJECT_FWD_GUARD
#define EFL_OBJECT_FWD_GUARD
namespace efl { 
struct Object;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object const&> : ::std::true_type {}; } }
#endif

namespace eo_cxx {
namespace efl { namespace ui { 
struct Clickable {
    static Efl_Class const* _eo_class()
    {
        return EFL_UI_CLICKABLE_INTERFACE;
    }
    Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Clickable *>(this))); }
    operator ::efl::ui::Clickable() const;
    operator ::efl::ui::Clickable&();
    operator ::efl::ui::Clickable const&() const;
    /// @cond LOCAL
     ::efl::eolian::address_of_operator<Clickable> operator&() { return {this}; }
     ::efl::eolian::address_of_operator<Clickable const > operator&() const { return {this}; }
    /// @endcond
};
} } 
}
namespace efl { namespace ui { 
struct Clickable : private ::efl::eo::concrete
{
    explicit Clickable( ::Eo* eo)
        : ::efl::eo::concrete(eo) {}
    Clickable(std::nullptr_t)
        : ::efl::eo::concrete(nullptr) {}
    explicit Clickable() = default;
    Clickable(Clickable const&) = default;
    Clickable(Clickable&&) = default;
    Clickable& operator=(Clickable const&) = default;
    Clickable& operator=(Clickable&&) = default;
    template <typename Derived>
    Clickable(Derived&& derived
        , typename std::enable_if<
            ::efl::eo::is_eolian_object<Derived>::value
             && std::is_base_of< Clickable, Derived>::value>::type* = 0)
            : ::efl::eo::concrete(derived._eo_ptr()) {}

    static Efl_Class const* _eo_class()
    {
        return EFL_UI_CLICKABLE_INTERFACE;
    }
    Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Clickable *>(this))); }
    static struct clicked_event
    {
        static Efl_Event_Description const* description()
        { return EFL_UI_EVENT_CLICKED; }
        typedef void parameter_type;
    } const clicked_event;
#ifdef EFL_CXXPERIMENTAL
    template <typename F>
    typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    clicked_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(clicked_event, *this, function);
    }
    template <typename F>
    typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    clicked_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(clicked_event, *this, std::bind(function));
    }
#endif
    static struct clicked_double_event
    {
        static Efl_Event_Description const* description()
        { return EFL_UI_EVENT_CLICKED_DOUBLE; }
        typedef void parameter_type;
    } const clicked_double_event;
#ifdef EFL_CXXPERIMENTAL
    template <typename F>
    typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    clicked_double_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(clicked_double_event, *this, function);
    }
    template <typename F>
    typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    clicked_double_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(clicked_double_event, *this, std::bind(function));
    }
#endif
    static struct clicked_triple_event
    {
        static Efl_Event_Description const* description()
        { return EFL_UI_EVENT_CLICKED_TRIPLE; }
        typedef void parameter_type;
    } const clicked_triple_event;
#ifdef EFL_CXXPERIMENTAL
    template <typename F>
    typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    clicked_triple_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(clicked_triple_event, *this, function);
    }
    template <typename F>
    typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    clicked_triple_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(clicked_triple_event, *this, std::bind(function));
    }
#endif
    static struct clicked_right_event
    {
        static Efl_Event_Description const* description()
        { return EFL_UI_EVENT_CLICKED_RIGHT; }
        typedef  ::efl::Object parameter_type;
    } const clicked_right_event;
#ifdef EFL_CXXPERIMENTAL
    template <typename F>
    typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    clicked_right_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(clicked_right_event, *this, function);
    }
    template <typename F>
    typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    clicked_right_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(clicked_right_event, *this, std::bind(function));
    }
#endif
    static struct pressed_event
    {
        static Efl_Event_Description const* description()
        { return EFL_UI_EVENT_PRESSED; }
        typedef  ::efl::Object parameter_type;
    } const pressed_event;
#ifdef EFL_CXXPERIMENTAL
    template <typename F>
    typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    pressed_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(pressed_event, *this, function);
    }
    template <typename F>
    typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    pressed_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(pressed_event, *this, std::bind(function));
    }
#endif
    static struct unpressed_event
    {
        static Efl_Event_Description const* description()
        { return EFL_UI_EVENT_UNPRESSED; }
        typedef  ::efl::Object parameter_type;
    } const unpressed_event;
#ifdef EFL_CXXPERIMENTAL
    template <typename F>
    typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    unpressed_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(unpressed_event, *this, function);
    }
    template <typename F>
    typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    unpressed_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(unpressed_event, *this, std::bind(function));
    }
#endif
    static struct longpressed_event
    {
        static Efl_Event_Description const* description()
        { return EFL_UI_EVENT_LONGPRESSED; }
        typedef  ::efl::Object parameter_type;
    } const longpressed_event;
#ifdef EFL_CXXPERIMENTAL
    template <typename F>
    typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    longpressed_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(longpressed_event, *this, function);
    }
    template <typename F>
    typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    longpressed_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(longpressed_event, *this, std::bind(function));
    }
#endif
    static struct repeated_event
    {
        static Efl_Event_Description const* description()
        { return EFL_UI_EVENT_REPEATED; }
        typedef void parameter_type;
    } const repeated_event;
#ifdef EFL_CXXPERIMENTAL
    template <typename F>
    typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    repeated_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(repeated_event, *this, function);
    }
    template <typename F>
    typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    repeated_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(repeated_event, *this, std::bind(function));
    }
#endif
    /// @cond LOCAL
     ::efl::eolian::address_of_operator<Clickable> operator&() { return {this}; }
     ::efl::eolian::address_of_operator<Clickable const > operator&() const { return {this}; }
    /// @endcond
    ::efl::eo::wref<Clickable> _get_wref() const { return ::efl::eo::wref<Clickable>(*this); }
    ::efl::eo::concrete const& _get_concrete() const { return *this; }
    ::efl::eo::concrete& _get_concrete() { return *this; }
    using ::efl::eo::concrete::_eo_ptr;
    using ::efl::eo::concrete::_release;
    using ::efl::eo::concrete::_reset;
    using ::efl::eo::concrete::_delete;
    using ::efl::eo::concrete::operator bool;
#ifdef EFL_CXXPERIMENTAL
    const Clickable* operator->() const { return this; }
    Clickable* operator->() { return this; }
    operator Eo*() const { return _eo_ptr(); }
#endif 
    friend bool operator==(Clickable const& lhs, Clickable const& rhs)
    { return lhs._get_concrete() == rhs._get_concrete(); }
    friend bool operator!=(Clickable const& lhs, Clickable const& rhs)
    { return !(lhs == rhs); }
};
static_assert(sizeof(Clickable) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Clickable>::value, "");
} } 
#endif
